diff --git a/Makerules b/Makerules
index fc9bf998..5c0fffa4 100644
--- a/Makerules
+++ b/Makerules
@@ -113,10 +113,14 @@ else ifeq ($(OS),Linux)
 	SYS_ZLIB_LIBS := $(shell pkg-config --libs zlib)
   endif
 
+  WANT_CURL ?= yes
+  ifeq "$(WANT_CURL)" "yes"
   HAVE_CURL := $(shell pkg-config --exists libcurl && echo yes)
   ifeq ($(HAVE_CURL),yes)
 	SYS_CURL_CFLAGS := $(shell pkg-config --cflags libcurl)
-	SYS_CURL_LIBS := $(shell pkg-config --libs libcurl)
+    # We have to forcibly add -lpthread to avoid linking errors.
+	SYS_CURL_LIBS := $(shell pkg-config --libs libcurl) -lpthread
+  endif
   endif
 
   HAVE_GLUT := yes
@@ -125,17 +129,29 @@ else ifeq ($(OS),Linux)
 	SYS_GLUT_LIBS := -lglut -lGL
   endif
 
+  WANT_X11 ?= yes
+  ifeq "$(WANT_X11)" "yes"
   HAVE_X11 := $(shell pkg-config --exists x11 xext && echo yes)
   ifeq ($(HAVE_X11),yes)
 	X11_CFLAGS := $(shell pkg-config --cflags x11 xext)
 	X11_LIBS := $(shell pkg-config --libs x11 xext)
   endif
+  endif
 
-  HAVE_LIBCRYPTO := $(shell pkg-config --exists 'libcrypto >= 1.1.0' && echo yes)
-  ifeq ($(HAVE_LIBCRYPTO),yes)
+  WANT_OPENSSL ?= yes
+  ifeq "$(WANT_OPENSSL)" "yes"
+  ifeq "$(shell pkg-config --exists 'libcrypto >= 2.0.0' && echo libre)" "libre"
+  ifeq "$(shell pkg-config --exists 'libcrypto >= 2.7.0' && echo yes)" "yes"
+    HAVE_LIBCRYPTO := yes
+	LIBCRYPTO_CFLAGS := $(shell pkg-config --cflags libcrypto) -DHAVE_LIBCRYPTO
+	LIBCRYPTO_LIBS := $(shell pkg-config --libs libcrypto)
+  endif
+  else ifeq "$(shell pkg-config --exists 'libcrypto >= 1.1.0' && echo yes)" "yes"
+    HAVE_LIBCRYPTO := yes
 	LIBCRYPTO_CFLAGS := $(shell pkg-config --cflags libcrypto) -DHAVE_LIBCRYPTO
 	LIBCRYPTO_LIBS := $(shell pkg-config --libs libcrypto)
   endif
+  endif
 
   HAVE_PTHREAD := yes
   ifeq ($(HAVE_PTHREAD),yes)
